/*
 * Peony-Qt's Library
 *
 * Copyright (C) 2019, Tianjin KYLIN Information Technology Co., Ltd.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library.  If not, see <https://www.gnu.org/licenses/>.
 *
 * Authors: Yue Lan <lanyue@kylinos.cn>
 *
 */

#ifndef COMPATIBLEOPENMENUPLUGIN_H
#define COMPATIBLEOPENMENUPLUGIN_H

#include "peony-menu-plugin-compatible-open_global.h"
#include <menu-plugin-iface.h>
#include "qlog.h"
#include <QObject>
#include <QtPlugin>

namespace Peony
{

    class PEONYQTMENUPLUGINCOMPATIBLEOPENSHARED_EXPORT CompatibleOpenMenuPlugin : public QObject, public MenuPluginInterface
    {
        Q_OBJECT
        Q_PLUGIN_METADATA(IID MenuPluginInterface_iid FILE "common.json")
        Q_INTERFACES(Peony::MenuPluginInterface)
    public:
        explicit CompatibleOpenMenuPlugin(QObject *parent = nullptr);

        PluginInterface::PluginType pluginType() override { return PluginInterface::MenuPlugin; }
        const QString name() override { return tr("Peony-Qt Compatible Open Menu Extension"); }
        const QString description() override { return tr("Open in Compatible Mode with menu"); }
        const QIcon icon() override { return QIcon::fromTheme("xjump"); }
        void setEnable(bool enable) override { m_enable = enable; }
        bool isEnable() override { return m_enable; }

        QString testPlugin() override { return "test"; }
        QList<QAction *> menuActions(Types types, const QString &uri, const QStringList &selectionUris) override;

    private:
        bool m_enable;
    };

}

#endif // COMPATIBLEOPENMENUPLUGIN_H
